//---------------------------------------------------------------------------
// mixes all the buffers, adds some post effects (delay, filter)
// and prepares buffer ready for playback

#ifndef buffer_mixerH
#define buffer_mixerH
//---------------------------------------------------------------------------

#include	"sample_defs.h"
#include 	"say.h"
#include	"types.h"

#include	"envelope.h"
#include	"sample_generator.h"

// no GET/SET methods for main params (save some bytes of intro)
// all the values are expected to be correct 
class CBufferMixer
{
// saving bytes:
public:

	bool	delay_on;
	byte	delay_level;
	byte	delay_time;

    bool	distortion_on;
    byte	distortion_max;
    byte	distortion_mirror;

    bool	filter_on;
    word	filter_freq;
    byte	filter_reso;
    
    // last existing buffer (not to make set method)
    int				buffer_last;
private:
	// refs to mixed buffs
	SMP_TYPE*		buffers[SMP_BUFFERS_MAX];
    // mixed normalized to -1..1
    SMP_TYPE		buffer[SMP_FREQ];
    int				buffer_size;
    // mixed and ready for playback (-32K..32K)
    SMP_TYPE_FIN	buffer_final[SMP_FREQ];
    int				buffer_final_size;
public:
	CBufferMixer();

    char	addBuffer(	SMP_TYPE*	new_buffer);
    // reset buffers when going to calc new ones (in case
    // some were added or deleted)
    void	reset();

    void    render();

    void	prepareFinalBuffer();
    SMP_TYPE*	getBuffer();

    SMP_TYPE_FIN*	getBufferFinal();
    int				getBufferSize();
    int				getBufferFinalSize();
};
#endif
