//---------------------------------------------------------------------------

#include "envelope.h"

//---------------------------------------------------------------------------

CEnvelope::CEnvelope()
{
	buffer_size	=	ENV_FREQ;
	buffer		=	new	ENV_TYPE[buffer_size];
    reset();
};
//CEnvelope::Cenvelope()

void	CEnvelope::reset()
{
	for (int i=0;i<ENV_PARAM_LAST;i++)params[i] = 0;
};
//CEnvelope::Cenvelope()

ENV_TYPE*	CEnvelope::calcBuffer()//returns ref to calced buffer (4 mixing)
{
	int	i,prev;

    ENV_TYPE*	tmp	=	buffer;
    // scale params to buffer size
    for(i=0,prev=0;i<=ENV_RELEASE_N;i++)
    {
        prev = (points[i].x =	(params[i] * buffer_size) / SMP_ENV_AMP + prev);
        points[i].y	=	params[ENV_BASE_N];
    }
    points[ENV_HOLD_N].y = points[ENV_ATTACK_N].y	=	params[ENV_AMPLITUDE_N];
    points[ENV_SUSTAIN_N].y = points[ENV_DECAY_N].y	 = params[ENV_MIDDLE_N];

	// identity env on base level
	for(i=0;i<buffer_size;i++,*tmp++=params[ENV_BASE_N]);

    //now fill all the remaining parts using linear interpolation
    for(i=0;i<ENV_RELEASE_N;i++)
    {
    	POINT* param1 = &points[i];
        POINT* param2 = &points[i+1];
    	for(int j=param1->x,k=0;j<param2->x;j++,k++)
        {
        	*(buffer+j)	=	param1->y + (param2->y - param1->y)*k/float(param2->x-param1->x);
        }
    }
	// normalize env to 1.0f
	for(i=0,tmp=buffer;i<buffer_size;i++)
	{
    	*tmp++	/= float(SMP_ENV_AMP);
	}
	return buffer;
};
//ENV_TYPE*	CEnvelope::calcBuffer()//returns ref to calced buffer (4 mixing)

int		CEnvelope::getBufferSize()
{
	return buffer_size;
};
//int		CEnvelope::getBufferSize()

ENV_TYPE*	CEnvelope::getBuffer()
{
	return buffer;
};
//ENV_TYPE*	CEnvelope::getBuffer()
