//---------------------------------------------------------------------------
// envelope structure

#ifndef envelopeH
#define envelopeH
//---------------------------------------------------------------------------

#include	"sample_defs.h"
#include 	"say.h"
#include	"types.h"

#define	ENV_FREQ		SMP_FREQ

// nums of params
#define	ENV_DELAY_N			0l
#define	ENV_ATTACK_N		1l
#define	ENV_HOLD_N			2l
#define	ENV_DECAY_N			3l
#define	ENV_SUSTAIN_N		4l
#define	ENV_RELEASE_N		5l

#define	ENV_BASE_N			6l
#define	ENV_AMPLITUDE_N		7l
#define	ENV_MIDDLE_N   		8l

#define	ENV_PARAM_LAST		9l

// num of points in envelope form (linear interpol. between points)
#define	ENV_POINTS_MAX	1+6+1

// no GET/SET methods for main params (save some bytes of intro)
// except the calced buffer
// all the values are expected to be correct 
// all params are bytes, but calced buffer is float!
class CEnvelope
{
private:
	ENV_TYPE*	buffer;
    int			buffer_size;
    // params scaled to buffer size
	int	delay_buf;
    int	attack_buf;
    int	hold_buf;
    int	decay_buf;
    int	sustain_buf;
    int	release_buf;

    POINT	points[ENV_POINTS_MAX];
public:
    byte	params[ENV_PARAM_LAST];

public:
	CEnvelope();
    void	reset();

    ENV_TYPE*	calcBuffer();//returns ref to calced buffer (4 mixing)
    ENV_TYPE*	getBuffer();
	int			getBufferSize();
};

#endif
