//---------------------------------------------------------------------------

#include "sample_generator.h"
//---------------------------------------------------------------------------
CSampleGenerator::CSampleGenerator()
{
	buffer_size		=	SMP_FREQ;
	buffer			=	new SMP_TYPE[buffer_size];
    reset();

};
//CSampleGenerator::CSampleGenerator()

void	CSampleGenerator::reset()
{
    func_num		=	0;
    amp	=	freq	=	0;
    // =0 => no envelope used (really equal to "Identity" env (1.f))
    amp_env_num		=	freq_env_num	=	0;
	amp_mod			=	freq_mod		=	false;
};
//void	CSampleGenerator::reset()

char	CSampleGenerator::generate(	ENV_TYPE*	new_amp_env,
    				   				ENV_TYPE*  	new_freq_env)
{
	env_one		=	1.f;// if no envelopes are given
    // setup increment for buffers (see below)
    amp_inc		=	amp_mod;
	freq_inc	=	freq_mod;

    //if NULL => just give a const value, but as if it was buffer
    amp_env =	/*new_amp_env == NULL*/!amp_mod ? &env_one : new_amp_env;
	freq_env =	!freq_mod/*new_freq_env == NULL*/ ? &env_one : new_freq_env;

    p_buf		=	&buffer[0];

    // for enveloped freq
    float	cur_freq;
    srand(123467);
	for (int i=0;i<buffer_size;i++)
	{
    	// calc enveloped freq
    	cur_freq=	freq * (*freq_env);
        // didn't bring to dif procs,
	    // could also use pointer 2 func, but these funcs still need
    	// different argument calculation
    	switch (func_num)
        {
        case SG_SIN:
        {
        	*p_buf	=	amp * sinf( 2*_PI*cur_freq * i / buffer_size );
        	break;
        }
        case SG_SQUARE:
        {
        	*p_buf	=	amp * sgn(sinf(2*_PI* cur_freq* i/buffer_size));
        	break;
        }

        case SG_SAW:
        {
        	*p_buf	=	cur_freq == 0? 0 : -amp +	2*( amp * (i%int(buffer_size/(cur_freq)))/(buffer_size/(cur_freq)));
        	break;
        }
        case SG_NOISE:
        {
        	*p_buf	=	-amp + 2*(rand()%(int(amp+1)));
        	break;
        }
        default:
            {
                say("CSampleGenerator::generate - wrong base form (%d).",func_num);
                return _ERROR;
            }
        }//switch

		*p_buf	*=	(*amp_env)/(SMP_DEF_AMP);
		p_buf++;
        amp_env 	+= amp_inc;
        freq_env 	+= i%2 ? 0 : freq_inc;
	}//for (int i

	return _OK;
};
//char	CSampleGenerator::generate()


SMP_TYPE*	CSampleGenerator::getBuffer()
{
	return &buffer[0];
};
//SMP_TYPE*	CSampleGenerator::getBuffer()

int			CSampleGenerator::getBufferSize()
{
	return buffer_size;
};
//int			CSampleGenerator::getBufferSize()

