//---------------------------------------------------------------------------
// basic form generator (can also envelope amp/freq) preparing
// 1 buffer for later mixing

#ifndef sample_generatorH
#define sample_generatorH
//---------------------------------------------------------------------------
#include	"sample_defs.h"
#include 	"say.h"
#include	"types.h"
#include	"util_mini.h"

#include 	"envelope.h"

// functions for buffer
#define	SG_SIN				0
#define	SG_SQUARE			1
#define	SG_SAW				2
#define	SG_NOISE			3

// for byte -> short conversion (final conversion for playback)
#define	SG_AMP_MUL_FIN				128

// no GET/SET methods for main params (save some bytes of intro)
// all the values are expected to be correct 
class CSampleGenerator
{
// save bytes with no access methods impl
public:
	SMP_TYPE	amp;
    word		freq;
    char		func_num;
    // stored just to have that info inside sample. Real
    // envelope buffers are given as proc params
    char		amp_env_num;
    char		freq_env_num;
    bool		amp_mod;
    bool		freq_mod;
private:
    ENV_TYPE*	amp_env;
    char		amp_inc;// increment for env buffer
    ENV_TYPE*	freq_env;
    char		freq_inc;// increment for env buffer

    ENV_TYPE	env_one;// const value =1, if no envelopes used

  	SMP_TYPE*	buffer;
    SMP_TYPE*	p_buf;// prepared for func_works
    int			buffer_size;
public:

	CSampleGenerator();
    void	reset();

    char	generate(	ENV_TYPE*	new_amp_env		= NULL,
    				   	ENV_TYPE*  	new_freq_env 	= NULL);
    SMP_TYPE*	getBuffer();
    int			getBufferSize();

};

#endif
