//---------------------------------------------------------------------------
// gets all sample params (inside STRUCT) and calculates sample
// ready for playback

#ifndef sample_managerH
#define sample_managerH
//---------------------------------------------------------------------------

#define		_MANAGER_INTRO_READY

#include	"sample_defs.h"
#include 	"say.h"
#include	"types.h"

#include	"envelope.h"
#include	"sample_generator.h"
#include	"buffer_mixer.h"

#define		_ENABLE_SAVE_SAMPLES

#ifdef		_ENABLE_SAVE_SAMPLES
// MAKE ifdef for all file WRITE routines
	#include "stdio.h"
#endif

#define		SAMPLE_MANAGER_VERSION	0x02

// no GET/SET methods for main params (save some bytes of intro)
// all the values are expected to be correct 
class CSampleManager
{
public:
	CEnvelope			envelopes[SMP_ENVELOPES_MAX];
    // actual number of envelopes used
    int					envelope_number;

    CSampleGenerator	buffers[SMP_BUFFERS_MAX];
    // actual number of sample buffers used
    int					buffer_number;

    CBufferMixer		mixer;

#ifdef		_ENABLE_SAVE_SAMPLES
    FILE*	f;
#endif

private:
	int			version;
    SMP_CMD_TYPE*			cur_position;
private:
	// get 1 elem from command list
    SMP_CMD_TYPE			readElem();

    char			writeElem(SMP_CMD_TYPE value);

public:
	CSampleManager();

    char	reset();

    // gets DSL (list of params) for sound to be generated
    char    generate(	SMP_CMD_TYPE*     new_list);

    char	saveFile(char* name);

    // get buffer ready for playback (e.g. can pass it to miniFMOD
    // funcs)
    SMP_TYPE_FIN*	getSample();
	int				getSampleSize();
};

#endif
